#include <stdlib.h>
#include "story.h"

Story::Story(int px, int py, char pl, Story* ppast)
{
  variants = 0;
  current = nbvariants = 0;
  past = ppast;
  x = px; y = py;
  commentary = 0;
  score[0] = score[1] = 0;
  player = pl;
}

Story::~Story()
{
  for (int i=0; i<nbvariants; i++) delete variants[i];
  free(variants);
  if (commentary) free(commentary);
}

void Story::add_move(Story* s)
{
  if (nbvariants)
    variants = (Story**) realloc(variants, sizeof(Story*)*(nbvariants+1));
  else
    variants = (Story**) malloc(sizeof(Story*));
  current = nbvariants;
  variants[nbvariants++] = s;
  s->past = this;
}

Story* Story::step()
{
  if (variants == 0) return 0;
  return variants[current];
}

Story* Story::back()
{
  return past;
}
